diff --git a/arch/ppc/platforms/ibm405ep.c b/arch/ppc/platforms/ibm405ep.c
new file mode 100644
--- /dev/null
+++ b/arch/ppc/platforms/ibm405ep.c
@@ -0,0 +1,132 @@
+/*
+ * arch/ppc/platforms/ibm405ep.c
+ *
+ * Support for IBM PPC 405EP processors.
+ *
+ * Author: SAW (IBM), derived from ibmnp405l.c.
+ *         Maintained by MontaVista Software <source@mvista.com>
+ *
+ * 2003 (c) MontaVista Softare Inc.  This file is licensed under the
+ * terms of the GNU General Public License version 2. This program is
+ * licensed "as is" without any warranty of any kind, whether express
+ * or implied.
+ */
+
+#include <linux/config.h>
+#include <linux/init.h>
+#include <linux/smp.h>
+#include <linux/threads.h>
+#include <linux/param.h>
+#include <linux/string.h>
+
+#include <asm/ibm4xx.h>
+#include <asm/ocp.h>
+#include <asm/ppc4xx_pic.h>
+
+#include <platforms/ibm405ep.h>
+
+static struct ocp_func_emac_data ibm405ep_emac0_def = {
+	.rgmii_idx	= -1,		/* No RGMII */
+	.rgmii_mux	= -1,		/* No RGMII */
+	.zmii_idx	= -1,		/* ZMII device index */
+	.zmii_mux	= 0,		/* ZMII input of this EMAC */
+	.mal_idx	= 0,		/* MAL device index */
+	.mal_rx_chan	= 0,		/* MAL rx channel number */
+	.mal_tx_chan	= 0,		/* MAL tx channel number */
+	.wol_irq	= 9,		/* WOL interrupt number */
+	.mdio_idx	= 0,		/* MDIO via EMAC0 */
+	.tah_idx	= -1,		/* No TAH */
+};
+
+static struct ocp_func_emac_data ibm405ep_emac1_def = {
+	.rgmii_idx	= -1,		/* No RGMII */
+	.rgmii_mux	= -1,		/* No RGMII */
+	.zmii_idx	= -1,		/* ZMII device index */
+	.zmii_mux	= 0,		/* ZMII input of this EMAC */
+	.mal_idx	= 0,		/* MAL device index */
+	.mal_rx_chan	= 1,		/* MAL rx channel number */
+	.mal_tx_chan	= 2,		/* MAL tx channel number */
+	.wol_irq	= 9,		/* WOL interrupt number */
+	.mdio_idx	= 0,		/* MDIO via EMAC0 */
+	.tah_idx	= -1,		/* No TAH */
+};
+
+static struct ocp_func_mal_data ibm405ep_mal0_def = {
+	.num_tx_chans	= 4,		/* Number of TX channels */
+	.num_rx_chans	= 2,		/* Number of RX channels */
+	.dcr_base	= DCRN_MAL_BASE,
+	.txeob_irq	= 11,		/* TX End Of Buffer IRQ  */
+	.rxeob_irq	= 12,		/* RX End Of Buffer IRQ  */
+	.txde_irq	= 13,		/* TX Descriptor Error IRQ */
+	.rxde_irq	= 14,		/* RX Descriptor Error IRQ */
+	.serr_irq	= 10,		/* MAL System Error IRQ    */
+};
+
+struct ocp_def core_ocp[]  = {
+/*	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_OPB,
+	  .index	= 0,
+	  .paddr	= 0xEF600000,
+	  .irq		= OCP_IRQ_NA,
+	  .pm		= OCP_CPM_NA,
+	},*/
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_16550,
+	  .index	= 0,
+	  .paddr	= UART0_IO_BASE,
+	  .irq		= UART0_INT,
+	  .pm		= IBM_CPM_UART0
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_16550,
+	  .index	= 1,
+	  .paddr	= UART1_IO_BASE,
+	  .irq		= UART1_INT,
+	  .pm		= IBM_CPM_UART1
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_IIC,
+	  .paddr	= 0xEF600500,
+	  .irq		= 2,
+	  .pm		= IBM_CPM_IIC0
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_GPIO,
+	  .paddr	= 0xEF600700,
+	  .irq		= OCP_IRQ_NA,
+	  .pm		= IBM_CPM_GPIO0
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_MAL,
+	  .paddr	= OCP_PADDR_NA,
+	  .irq		= OCP_IRQ_NA,
+	  .pm		= OCP_CPM_NA,
+	  .additions	= &ibm405ep_mal0_def,
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_EMAC,
+	  .index	= 0,
+	  .paddr	= EMAC0_BASE,
+	  .irq		= 15,
+	  .pm		= OCP_CPM_NA,
+	  .additions	= &ibm405ep_emac0_def,
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_EMAC,
+	  .index	= 1,
+	  .paddr	= 0xEF600900,
+	  .irq		= 17,
+	  .pm		= OCP_CPM_NA,
+	  .additions	= &ibm405ep_emac1_def,
+	},
+	{ .vendor	= OCP_VENDOR_INVALID
+	}
+};
+
+/* Polarity and triggering settings for internal interrupt sources */
+struct ppc4xx_uic_settings ppc4xx_core_uic_cfg[] __initdata = {
+	{ .polarity 	= 0xffff7f80,
+	  .triggering	= 0x00000000,
+	  .ext_irq_mask	= 0x0000007f,	/* IRQ0 - IRQ6 */
+	}
+};
diff --git a/arch/ppc/platforms/ibm405ep.h b/arch/ppc/platforms/ibm405ep.h
new file mode 100644
--- /dev/null
+++ b/arch/ppc/platforms/ibm405ep.h
@@ -0,0 +1,218 @@
+/*
+ * arch/ppc/platforms/ibm405ep.h
+ *
+ * IBM PPC 405EP processor defines.
+ *
+ * Author: SAW (IBM), derived from ibm405gp.h.
+ *         Maintained by MontaVista Software <source@mvista.com>
+ *
+ * 2003 (c) MontaVista Softare Inc.  This file is licensed under the
+ * terms of the GNU General Public License version 2. This program is
+ * licensed "as is" without any warranty of any kind, whether express
+ * or implied.
+ */
+
+#ifdef __KERNEL__
+#ifndef __ASM_IBM405EP_H__
+#define __ASM_IBM405EP_H__
+
+#include <linux/config.h>
+#include <platforms/ibm_ocp.h>
+
+/* ibm405.h at bottom of this file */
+
+/* PCI
+ * PCI Bridge config reg definitions
+ * see 17-19 of manual
+ */
+
+#define PPC405_PCI_CONFIG_ADDR	0xeec00000
+#define PPC405_PCI_CONFIG_DATA	0xeec00004
+
+#define PPC405_PCI_PHY_MEM_BASE	0x80000000	/* hose_a->pci_mem_offset */
+						/* setbat */
+#define PPC405_PCI_MEM_BASE	PPC405_PCI_PHY_MEM_BASE	/* setbat */
+#define PPC405_PCI_PHY_IO_BASE	0xe8000000	/* setbat */
+#define PPC405_PCI_IO_BASE	PPC405_PCI_PHY_IO_BASE	/* setbat */
+
+#define PPC405_PCI_LOWER_MEM	0x80000000	/* hose_a->mem_space.start */
+#define PPC405_PCI_UPPER_MEM	0xBfffffff	/* hose_a->mem_space.end */
+#define PPC405_PCI_LOWER_IO	0x00000000	/* hose_a->io_space.start */
+#define PPC405_PCI_UPPER_IO	0x0000ffff	/* hose_a->io_space.end */
+
+#define PPC405_ISA_IO_BASE	PPC405_PCI_IO_BASE
+
+#define PPC4xx_PCI_IO_PADDR	((uint)PPC405_PCI_PHY_IO_BASE)
+#define PPC4xx_PCI_IO_VADDR	PPC4xx_PCI_IO_PADDR
+#define PPC4xx_PCI_IO_SIZE	((uint)64*1024)
+#define PPC4xx_PCI_CFG_PADDR	((uint)PPC405_PCI_CONFIG_ADDR)
+#define PPC4xx_PCI_CFG_VADDR	PPC4xx_PCI_CFG_PADDR
+#define PPC4xx_PCI_CFG_SIZE	((uint)4*1024)
+#define PPC4xx_PCI_LCFG_PADDR	((uint)0xef400000)
+#define PPC4xx_PCI_LCFG_VADDR	PPC4xx_PCI_LCFG_PADDR
+#define PPC4xx_PCI_LCFG_SIZE	((uint)4*1024)
+#define PPC4xx_ONB_IO_PADDR	((uint)0xef600000)
+#define PPC4xx_ONB_IO_VADDR	PPC4xx_ONB_IO_PADDR
+#define PPC4xx_ONB_IO_SIZE	((uint)4*1024)
+
+/* serial port defines */
+#define UART0_INT	0
+#define UART1_INT	1
+
+#define PCIL0_BASE	0xEF400000
+#define UART0_IO_BASE	0xEF600300
+#define UART1_IO_BASE	0xEF600400
+#define EMAC0_BASE	0xEF600800
+
+#define BD_EMAC_ADDR(e,i) bi_enetaddr[e][i]
+
+#if defined(CONFIG_UART0_TTYS0)
+#define ACTING_UART0_IO_BASE	UART0_IO_BASE
+#define ACTING_UART1_IO_BASE	UART1_IO_BASE
+#define ACTING_UART0_INT	UART0_INT
+#define ACTING_UART1_INT	UART1_INT
+#else
+#define ACTING_UART0_IO_BASE	UART1_IO_BASE
+#define ACTING_UART1_IO_BASE	UART0_IO_BASE
+#define ACTING_UART0_INT	UART1_INT
+#define ACTING_UART1_INT	UART0_INT
+#endif
+
+#define STD_UART_OP(num)					\
+	{ 0, BASE_BAUD, 0, ACTING_UART##num##_INT,			\
+		(ASYNC_BOOT_AUTOCONF | ASYNC_SKIP_TEST),	\
+		iomem_base: (u8 *)ACTING_UART##num##_IO_BASE,		\
+		io_type: SERIAL_IO_MEM},
+
+#define SERIAL_DEBUG_IO_BASE	ACTING_UART0_IO_BASE
+#define RS_TABLE_SIZE	2
+#define SERIAL_PORT_DFNS	\
+	STD_UART_OP(0)		\
+	STD_UART_OP(1)
+
+/* DCR defines */
+#define DCRN_CPMSR_BASE         	0x0BA
+#define DCRN_CPMFR_BASE         	0x0B9
+
+#define DCRN_CPC0_PLLMR0_BASE   	0x0F0
+#define DCRN_CPC0_BOOT_BASE     	0x0F1
+#define DCRN_CPC0_CR1_BASE      	0x0F2
+#define DCRN_CPC0_EPRCSR_BASE   	0x0F3
+#define DCRN_CPC0_PLLMR1_BASE   	0x0F4
+#define DCRN_CPC0_PLLMR1_FWDDIVA	0x00070000
+#define DCRN_CPC0_PLLMR1_FWDDIVA_SHIFT	16
+#define DCRN_CPC0_UCR_BASE      	0x0F5
+#define DCRN_CPC0_UCR_U0DIV     	0x007F
+#define DCRN_CPC0_UCR_U1DIV     	0x7F00
+#define DCRN_CPC0_UCR_U1DIV_SHIFT 	8
+#define DCRN_CPC0_SRR_BASE      	0x0F6
+#define DCRN_CPC0_JTAGID_BASE   	0x0F7
+#define DCRN_CPC0_SPARE_BASE    	0x0F8
+#define DCRN_CPC0_PCI_BASE      	0x0F9
+
+
+#define IBM_CPM_GPT             0x80000000      /* GPT interface */
+#define IBM_CPM_PCI             0x40000000      /* PCI bridge */
+#define IBM_CPM_UIC             0x00010000      /* Universal Int Controller */
+#define IBM_CPM_CPU             0x00008000      /* processor core */
+#define IBM_CPM_EBC             0x00002000      /* EBC controller */
+#define IBM_CPM_SDRAM0          0x00004000      /* SDRAM memory controller */
+#define IBM_CPM_GPIO0           0x00001000      /* General Purpose IO */
+#define IBM_CPM_TMRCLK          0x00000400      /* CPU timers */
+#define IBM_CPM_PLB             0x00000100      /* PLB bus arbiter */
+#define IBM_CPM_OPB             0x00000080      /* PLB to OPB bridge */
+#define IBM_CPM_DMA             0x00000040      /* DMA controller */
+#define IBM_CPM_IIC0            0x00000010      /* IIC interface */
+#define IBM_CPM_UART1           0x00000002      /* serial port 0 */
+#define IBM_CPM_UART0           0x00000001      /* serial port 1 */
+#define DFLT_IBM4xx_PM          ~(IBM_CPM_PCI | IBM_CPM_CPU | IBM_CPM_DMA \
+                                        | IBM_CPM_OPB | IBM_CPM_EBC \
+                                        | IBM_CPM_SDRAM0 | IBM_CPM_PLB \
+                                        | IBM_CPM_UIC | IBM_CPM_TMRCLK)
+#define DCRN_DMA0_BASE          0x100
+#define DCRN_DMA1_BASE          0x108
+#define DCRN_DMA2_BASE          0x110
+#define DCRN_DMA3_BASE          0x118
+#define DCRNCAP_DMA_SG          1       /* have DMA scatter/gather capability */
+#define DCRN_DMASR_BASE         0x120
+#define DCRN_EBC_BASE           0x012
+#define DCRN_DCP0_BASE          0x014
+#define DCRN_MAL_BASE           0x180
+#define DCRN_OCM0_BASE          0x018
+#define DCRN_PLB0_BASE          0x084
+#define DCRN_PLLMR_BASE         0x0B0
+#define DCRN_POB0_BASE          0x0A0
+#define DCRN_SDRAM0_BASE        0x010
+#define DCRN_UIC0_BASE          0x0C0
+#define UIC0 DCRN_UIC0_BASE
+
+/* External Bus Controller */
+
+/* EBC DCR Addresses */
+#define DCRN_EBC0_CFGADDR	0x012	/* EBC Address Register r/w */
+#define DCRN_EBC0_CFGDATA	0x013	/* EBC Data Register r/w    */
+
+/*
+  EBC configuration and status registers 
+  (accessed indirectly through  DCRN_EBC0_CFGADDR and DCRN_EBC0_CFGDATA)
+*/
+#define EBC0_BANK_COUNT	8
+
+#define EBC0_BCR_BASE	0x00
+#define EBC0_B0CR  0x00	/* Peripheral Bank 0 Configuration Register (r/w) */
+#define EBC0_B1CR  0x01	/* Peripheral Bank 1 Configuration Register (r/w) */
+#define EBC0_B2CR  0x02	/* Peripheral Bank 2 Configuration Register (r/w) */
+#define EBC0_B3CR  0x03	/* Peripheral Bank 3 Configuration Register (r/w) */
+#define EBC0_B4CR  0x04	/* Peripheral Bank 4 Configuration Register (r/w) */
+#define EBC0_B5CR  0x05	/* Peripheral Bank 5 Configuration Register (r/w) */
+#define EBC0_B6CR  0x06	/* Peripheral Bank 6 Configuration Register (r/w) */
+#define EBC0_B7CR  0x07	/* Peripheral Bank 7 Configuration Register (r/w) */
+
+#define EBC0_BAP_BASE	0x10
+#define EBC0_B0AP  0x10	/* Peripheral Bank 0 Access Parameter Register (r/w) */
+#define EBC0_B1AP  0x11	/* Peripheral Bank 1 Access Parameter Register (r/w) */
+#define EBC0_B2AP  0x12	/* Peripheral Bank 2 Access Parameter Register (r/w) */
+#define EBC0_B3AP  0x13	/* Peripheral Bank 3 Access Parameter Register (r/w) */
+#define EBC0_B4AP  0x14	/* Peripheral Bank 4 Access Parameter Register (r/w) */
+#define EBC0_B5AP  0x15	/* Peripheral Bank 5 Access Parameter Register (r/w) */
+#define EBC0_B6AP  0x16	/* Peripheral Bank 6 Access Parameter Register (r/w) */
+#define EBC0_B7AP  0x17	/* Peripheral Bank 7 Access Parameter Register (r/w) */
+
+#define EBC0_BEAR  0x20	/* Perihperal Bus Error Address Register (r/o) */
+#define EBC0_BESR0 0x21	/* Peripheral Bus Error Status  Register 0 (r/w) */
+#define EBC0_BESR1 0x22	/* Peripheral Bus Error Status  Register 1 (r/w) */
+
+#define EBC0_CFG   0x23	/* External Bus Configuration Register (r/w) */
+#define EBC0_CID   0x24	/* EBC ID Register (r/o) */
+
+/* EBC0_B0CR - EBC0_B7CR fields */
+#define EBC_CFG_BAS_MASK	0xfff00000
+
+#define EBC_CFG_BANK_SIZE_MASK	0x000e0000
+#define EBC_CFG_BANK_SIZE(reg)	(((reg) & EBC_CFG_BANK_SIZE_MASK) >> 17)
+#define EBC_CFG_SIZE_1M		0x0
+#define EBC_CFG_SIZE_2M		0x1
+#define EBC_CFG_SIZE_4M		0x2
+#define EBC_CFG_SIZE_8M		0x3
+#define EBC_CFG_SIZE_16M	0x4
+#define EBC_CFG_SIZE_32M	0x5
+#define EBC_CFG_SIZE_64M	0x6
+#define EBC_CFG_SIZE_128M	0x7
+
+#define EBC_CFG_BANK_USAGE_MASK	0x00018000
+#define EBC_CFG_BANK_USAGE(reg)	(((reg) & EBC_CFG_BANK_USAGE_MASK) >> 15)
+#define EBC_CFG_DISABLED	0x0
+#define EBC_CFG_READONLY	0x1
+#define EBC_CFG_WRITEONLY	0x2
+#define EBC_CFG_READWRITE	0x3
+
+#define EBC_CFG_BANK_WIDTH_MASK	0x00006000
+#define EBC_CFG_BANK_WIDTH(reg)	(((reg) & EBC_CFG_BANK_WIDTH_MASK) >> 13)
+#define EBC_CFG_WIDTH_8		0x0
+#define EBC_CFG_WIDTH_16	0x1
+#define EBC_CFG_WIDTH_32	0x3
+
+#include <platforms/ibm405.h>
+
+#endif				/* __ASM_IBM405EP_H__ */
+#endif				/* __KERNEL__ */
diff --git a/arch/ppc/platforms/ibm405gp.c b/arch/ppc/platforms/ibm405gp.c
--- a/arch/ppc/platforms/ibm405gp.c
+++ b/arch/ppc/platforms/ibm405gp.c
@@ -7,24 +7,10 @@
  *
  *
  * This program is free software; you can redistribute  it and/or modify it
- *  under  the terms of  the GNU General Public License as published by the
- *  Free Software Foundation;  either version 2 of the  License, or (at your
- *  option) any later version.
+ * under  the terms of  the GNU General Public License as published by the
+ * Free Software Foundation;  either version 2 of the  License, or (at your
+ * option) any later version.
  *
- *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR   IMPLIED
- *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
- *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
- *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT,  INDIRECT,
- *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
- *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
- *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
- *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- *
- *  You should have received a copy of the  GNU General Public License along
- *  with this program; if not, write  to the Free Software Foundation, Inc.,
- *  675 Mass Ave, Cambridge, MA 02139, USA.
  */
 
 #include <linux/config.h>
@@ -36,28 +22,37 @@
 #include <platforms/ibm405gp.h>
 #include <asm/ibm4xx.h>
 #include <asm/ocp.h>
+#include <asm/ppc4xx_pic.h>
 
 static struct ocp_func_emac_data ibm405gp_emac0_def = {
+	.rgmii_idx	= -1,		/* No RGMII */
+	.rgmii_mux	= -1,		/* No RGMII */
 	.zmii_idx	= -1,		/* ZMII device index */
 	.zmii_mux	= 0,		/* ZMII input of this EMAC */
 	.mal_idx	= 0,		/* MAL device index */
 	.mal_rx_chan	= 0,		/* MAL rx channel number */
-	.mal_tx1_chan	= 0,		/* MAL tx channel 1 number */
-	.mal_tx2_chan	= 1,		/* MAL tx channel 2 number */
-	.wol_irq	= BL_MAC_WOL,	/* WOL interrupt number */
+	.mal_tx_chan	= 0,		/* MAL tx channel number */
+	.wol_irq	= 9,		/* WOL interrupt number */
 	.mdio_idx	= -1,		/* No shared MDIO */
+	.tah_idx	= -1,		/* No TAH */
 };
 
 static struct ocp_func_mal_data ibm405gp_mal0_def = {
-	.num_tx_chans	= 2*EMAC_NUMS,	/* Number of TX channels */
-	.num_rx_chans	= EMAC_NUMS,	/* Number of RX channels */
+	.num_tx_chans	= 1,		/* Number of TX channels */
+	.num_rx_chans	= 1,		/* Number of RX channels */
+	.dcr_base	= DCRN_MAL_BASE,
+	.txeob_irq	= 11,		/* TX End Of Buffer IRQ  */
+	.rxeob_irq	= 12,		/* RX End Of Buffer IRQ  */
+	.txde_irq	= 13,		/* TX Descriptor Error IRQ */
+	.rxde_irq	= 14,		/* RX Descriptor Error IRQ */
+	.serr_irq	= 10,		/* MAL System Error IRQ    */
 };
 
-struct ocp_def core_ocp[]  __initdata = {
+struct ocp_def core_ocp[] = {
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_OPB,
 	  .index	= 0,
-	  .paddr	= OPB_BASE_START,
+	  .paddr	= 0xEF600000,
 	  .irq		= OCP_IRQ_NA,
 	  .pm		= OCP_CPM_NA,
 	},
@@ -77,13 +72,13 @@ struct ocp_def core_ocp[]  __initdata = 
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_IIC,
-	  .paddr	= IIC0_BASE,
-	  .irq		= IIC0_IRQ,
+	  .paddr	= 0xEF600500,
+	  .irq		= 2,
 	  .pm		= IBM_CPM_IIC0
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_GPIO,
-	  .paddr	= GPIO0_BASE,
+	  .paddr	= 0xEF600700,
 	  .irq		= OCP_IRQ_NA,
 	  .pm		= IBM_CPM_GPIO0
 	},
@@ -98,10 +93,18 @@ struct ocp_def core_ocp[]  __initdata = 
 	  .function	= OCP_FUNC_EMAC,
 	  .index	= 0,
 	  .paddr	= EMAC0_BASE,
-	  .irq		= BL_MAC_ETH0,
+	  .irq		= 15,
 	  .pm		= IBM_CPM_EMAC0,
 	  .additions	= &ibm405gp_emac0_def,
 	},
 	{ .vendor	= OCP_VENDOR_INVALID
 	}
 };
+
+/* Polarity and triggering settings for internal interrupt sources */
+struct ppc4xx_uic_settings ppc4xx_core_uic_cfg[] __initdata = {
+	{ .polarity 	= 0xffffff80,
+	  .triggering	= 0x10000000,
+	  .ext_irq_mask	= 0x0000007f,	/* IRQ0 - IRQ6 */
+	}
+};
diff --git a/arch/ppc/platforms/ibm405gp.h b/arch/ppc/platforms/ibm405gp.h
--- a/arch/ppc/platforms/ibm405gp.h
+++ b/arch/ppc/platforms/ibm405gp.h
@@ -1,35 +1,12 @@
 /*
- * ibm405gp.h
+ * arch/ppc/platforms/4xx/ibm405gp.h
  *
- *	This was derived from the ppc4xx.h and all 405GP specific
- *	definition and board inclusions were moved here.
- *
- *      Original author: Armin Kuster akuster@mvista.com
- *      Oct, 2001
- *
- *
- * Copyright 2001 MontaVista Softare Inc.
- *
- * This program is free software; you can redistribute  it and/or modify it
- *  under  the terms of  the GNU General Public License as published by the
- *  Free Software Foundation;  either version 2 of the  License, or (at your
- *  option) any later version.
- *
- *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR   IMPLIED
- *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
- *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
- *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT,  INDIRECT,
- *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
- *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
- *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
- *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- *
- *  You should have received a copy of the  GNU General Public License along
- *  with this program; if not, write  to the Free Software Foundation, Inc.,
- *  675 Mass Ave, Cambridge, MA 02139, USA.
+ * Author: Armin Kuster akuster@mvista.com
  *
+ * 2001 (c) MontaVista, Software, Inc.  This file is licensed under
+ * the terms of the GNU General Public License version 2.  This program
+ * is licensed "as is" without any warranty of any kind, whether express
+ * or implied.
  */
 
 #ifdef __KERNEL__
@@ -74,9 +51,6 @@
 #define PPC4xx_ONB_IO_VADDR	PPC4xx_ONB_IO_PADDR
 #define PPC4xx_ONB_IO_SIZE	((uint)4*1024)
 
-#define OPB_BASE_START	0x40000000
-#define EBIU_BASE_START	0xF0100000
-
 /* serial port defines */
 #define RS_TABLE_SIZE	2
 
@@ -86,24 +60,8 @@
 #define PCIL0_BASE	0xEF400000
 #define UART0_IO_BASE	0xEF600300
 #define UART1_IO_BASE	0xEF600400
-#define IIC0_BASE	0xEF600500
-#define OPB0_BASE	0xEF600600
-#define GPIO0_BASE	0xEF600700
 #define EMAC0_BASE	0xEF600800
-#define BL_MAC_WOL	9	/* WOL */
-#define BL_MAL_SERR	10	/* MAL SERR */
-#define BL_MAL_TXDE	13	/* MAL TXDE */
-#define BL_MAL_RXDE	14	/* MAL RXDE */
-#define BL_MAL_TXEOB	11	/* MAL TX EOB */
-#define BL_MAL_RXEOB	12	/* MAL RX EOB */
-#define BL_MAC_ETH0	15	/* MAC */
-
-#define EMAC_NUMS	1
-#define IIC0_IRQ	2
-#define IIC1_IRQ	0
 
-#define IIC_OWN		0x55
-#define IIC_CLOCK	50
 #define BD_EMAC_ADDR(e,i) bi_enetaddr[i]
 
 #define STD_UART_OP(num)					\
diff --git a/arch/ppc/platforms/ibm440gp.c b/arch/ppc/platforms/ibm440gp.c
--- a/arch/ppc/platforms/ibm440gp.c
+++ b/arch/ppc/platforms/ibm440gp.c
@@ -7,7 +7,7 @@
  * Copyright 2002-2003 MontaVista Software Inc.
  *
  * Eugene Surovegin <eugene.surovegin@zultys.com> or <ebs@ebshome.net>
- * Copyright (c) 2003 Zultys Technologies
+ * Copyright (c) 2003, 2004 Zultys Technologies
  *
  * This program is free software; you can redistribute  it and/or modify it
  * under  the terms of  the GNU General  Public License as published by the
@@ -15,48 +15,55 @@
  * option) any later version.
  *
  */
-#include <linux/init.h>
+#include <linux/config.h>
 #include <linux/module.h>
+#include <linux/init.h>
 #include <platforms/ibm440gp.h>
 #include <asm/ocp.h>
-
-#if defined(EMAC_NUMS) && EMAC_NUMS > 0
-u32 emac_phy_map[EMAC_NUMS];
-EXPORT_SYMBOL(emac_phy_map);
-#endif
+#include <asm/ppc4xx_pic.h>
 
 static struct ocp_func_emac_data ibm440gp_emac0_def = {
+	.rgmii_idx	= -1,           /* No RGMII */
+	.rgmii_mux	= -1,           /* No RGMII */
 	.zmii_idx       = 0,            /* ZMII device index */
 	.zmii_mux       = 0,            /* ZMII input of this EMAC */
 	.mal_idx        = 0,            /* MAL device index */
 	.mal_rx_chan    = 0,            /* MAL rx channel number */
-	.mal_tx1_chan   = 0,            /* MAL tx channel 1 number */
-	.mal_tx2_chan   = 1,            /* MAL tx channel 2 number */
-	.wol_irq        = BL_MAC_WOL,   /* WOL interrupt number */
+	.mal_tx_chan    = 0,            /* MAL tx channel number */
+	.wol_irq        = 61,		/* WOL interrupt number */
 	.mdio_idx       = -1,           /* No shared MDIO */
+	.tah_idx	= -1,           /* No TAH */
 };
 
 static struct ocp_func_emac_data ibm440gp_emac1_def = {
+	.rgmii_idx	= -1,           /* No RGMII */
+	.rgmii_mux	= -1,           /* No RGMII */
 	.zmii_idx       = 0,            /* ZMII device index */
 	.zmii_mux       = 1,            /* ZMII input of this EMAC */
 	.mal_idx        = 0,            /* MAL device index */
 	.mal_rx_chan    = 1,            /* MAL rx channel number */
-	.mal_tx1_chan   = 2,            /* MAL tx channel 1 number */
-	.mal_tx2_chan   = 3,            /* MAL tx channel 2 number */
-	.wol_irq        = BL_MAC_WOL1,   /* WOL interrupt number */
+	.mal_tx_chan    = 2,            /* MAL tx channel number */
+	.wol_irq        = 63,  		/* WOL interrupt number */
 	.mdio_idx       = -1,           /* No shared MDIO */
+	.tah_idx	= -1,           /* No TAH */
 };
 
 static struct ocp_func_mal_data ibm440gp_mal0_def = {
-	.num_tx_chans   = 2*EMAC_NUMS,  /* Number of TX channels */
-	.num_rx_chans   = EMAC_NUMS,    /* Number of RX channels */
+	.num_tx_chans   = 4,  		/* Number of TX channels */
+	.num_rx_chans   = 2,    	/* Number of RX channels */
+	.dcr_base	= DCRN_MAL_BASE,
+	.txeob_irq	= 10,		/* TX End Of Buffer IRQ  */
+	.rxeob_irq	= 11,		/* RX End Of Buffer IRQ  */
+	.txde_irq	= 33,		/* TX Descriptor Error IRQ */
+	.rxde_irq	= 34,		/* RX Descriptor Error IRQ */
+	.serr_irq	= 32,		/* MAL System Error IRQ    */
 };
 
-struct ocp_def core_ocp[] __initdata = {
+struct ocp_def core_ocp[] = {
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_OPB,
 	  .index	= 0,
-	  .paddr	= PPC440GP_OPB_BASE_START,
+	  .paddr	= 0x0000000140000000ULL,
 	  .irq		= OCP_IRQ_NA,
 	  .pm		= OCP_CPM_NA,
 	},
@@ -77,21 +84,20 @@ struct ocp_def core_ocp[] __initdata = {
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_IIC,
 	  .index	= 0,
-	  .paddr	= PPC440GP_IIC0_ADDR,
-	  .irq		= IIC0_IRQ,
+	  .paddr	= 0x0000000140000400ULL,
+	  .irq		= 2,
 	  .pm		= IBM_CPM_IIC0,
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_IIC,
 	  .index	= 1,
-	  .paddr	= PPC440GP_IIC1_ADDR,
-	  .irq		= IIC1_IRQ,
+	  .paddr	= 0x0000000140000500ULL,
+	  .irq		= 3,
 	  .pm		= IBM_CPM_IIC1,
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_GPIO,
-	  .index	= 0,
-	  .paddr	= PPC440GP_GPIO0_ADDR,
+	  .paddr	= 0x0000000140000700ULL,
 	  .irq		= OCP_IRQ_NA,
 	  .pm		= IBM_CPM_GPIO0,
 	},
@@ -105,25 +111,37 @@ struct ocp_def core_ocp[] __initdata = {
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_EMAC,
 	  .index	= 0,
-	  .paddr	= PPC440GP_EMAC0_ADDR,
-	  .irq		= BL_MAC_ETH0,
+	  .paddr	= 0x0000000140000800ULL,
+	  .irq		= 60,
 	  .pm		= OCP_CPM_NA,
 	  .additions	= &ibm440gp_emac0_def,
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_EMAC,
 	  .index	= 1,
-	  .paddr	= PPC440GP_EMAC1_ADDR,
-	  .irq		= BL_MAC_ETH1,
+	  .paddr	= 0x0000000140000900ULL,
+	  .irq		= 62,
 	  .pm		= OCP_CPM_NA,
 	  .additions	= &ibm440gp_emac1_def,
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_ZMII,
-	  .paddr	= PPC440GP_ZMII_ADDR,
+	  .paddr	= 0x0000000140000780ULL,
 	  .irq		= OCP_IRQ_NA,
 	  .pm		= OCP_CPM_NA,
 	},
 	{ .vendor	= OCP_VENDOR_INVALID
 	}
 };
+
+/* Polarity and triggering settings for internal interrupt sources */
+struct ppc4xx_uic_settings ppc4xx_core_uic_cfg[] __initdata = {
+	{ .polarity 	= 0xfffffe03,
+	  .triggering	= 0x01c00000,
+	  .ext_irq_mask	= 0x000001fc,	/* IRQ0 - IRQ6 */
+	},
+	{ .polarity 	= 0xffffc0ff,
+	  .triggering	= 0x00ff8000,
+	  .ext_irq_mask	= 0x00003f00,	/* IRQ7 - IRQ12 */
+	},
+};
diff --git a/arch/ppc/platforms/ibm440gp.h b/arch/ppc/platforms/ibm440gp.h
--- a/arch/ppc/platforms/ibm440gp.h
+++ b/arch/ppc/platforms/ibm440gp.h
@@ -24,47 +24,12 @@
 
 #include <asm/ibm44x.h>
 
-#define EMAC_NUMS		2
-#define UART_NUMS		2
-#define ZMII_NUMS		1
-#define IIC_NUMS		2
-#define IIC0_IRQ		2
-#define IIC1_IRQ		3
-#define GPIO_NUMS		1
-
-/* UART location */
+/* UART */
 #define PPC440GP_UART0_ADDR	0x0000000140000200ULL
 #define PPC440GP_UART1_ADDR	0x0000000140000300ULL
 #define UART0_INT		0
 #define UART1_INT		1
 
-/* EMAC location */
-#define PPC440GP_EMAC0_ADDR	0x0000000140000800ULL
-#define PPC440GP_EMAC1_ADDR	0x0000000140000900ULL
-#define PPC440GP_EMAC_SIZE	0x70
-
-/* EMAC IRQ's */
-#define BL_MAC_WOL	61	/* WOL */
-#define BL_MAC_WOL1	63	/* WOL */
-#define BL_MAL_SERR	32	/* MAL SERR */
-#define BL_MAL_TXDE	33	/* MAL TXDE */
-#define BL_MAL_RXDE	34	/* MAL RXDE */
-#define BL_MAL_TXEOB	10	/* MAL TX EOB */
-#define BL_MAL_RXEOB	11	/* MAL RX EOB */
-#define BL_MAC_ETH0	60	/* MAC */
-#define BL_MAC_ETH1	62	/* MAC */
-
-/* ZMII location */
-#define PPC440GP_ZMII_ADDR	0x0000000140000780ULL
-#define PPC440GP_ZMII_SIZE	0x0c
-
-/* I2C location */
-#define PPC440GP_IIC0_ADDR	0x40000400
-#define PPC440GP_IIC1_ADDR	0x40000500
-
-/* GPIO location */
-#define PPC440GP_GPIO0_ADDR	0x0000000140000700ULL
-
 /* Clock and Power Management */
 #define IBM_CPM_IIC0		0x80000000	/* IIC interface */
 #define IBM_CPM_IIC1		0x40000000	/* IIC interface */
@@ -91,9 +56,6 @@
 				| IBM_CPM_EBC | IBM_CPM_SRAM | IBM_CPM_BGO \
 				| IBM_CPM_EBM | IBM_CPM_PLB | IBM_CPM_OPB \
 				| IBM_CPM_TMRCLK | IBM_CPM_DMA | IBM_CPM_PCI)
-
-#define PPC440GP_OPB_BASE_START	0x0000000140000000ULL
-
 /*
  * Serial port defines
  */
